#include <libglademm/xml.h>
#include <gtkmm.h>
#include <iostream>
#include <vector>

using namespace std;

#include <boost/shared_ptr.hpp>

using namespace boost;

#include "widgets/TreeViewObject.h"
#include "widgets/TreeViewBase.h"
#include "widgets/ListViewBase.h"
#include "widgets/TreeViewDerived.h"
#include "widgets/ListViewDerived.h"

#include "AppData.h"

/////////////////////////////////////////////////////////////////////

AppData data;

/////////////////////////////////////////////////////////////////////

int main (int argc, char **argv)
{
  Gtk::Main kit(argc, argv);

  //Load the Glade file and instiate its widgets:
  Glib::RefPtr<Gnome::Glade::Xml> refXml;
  try
  {
    refXml = Gnome::Glade::Xml::create("ui/TreeViewBase.glade");
  }
  catch(const Gnome::Glade::XmlError& ex)
  {
    std::cerr << ex.what() << std::endl;
    return 1;
  }

  Gtk::Window* pWindow;

  refXml->get_widget( "window2", pWindow );
  if( pWindow )
  {
    refXml->get_widget_derived( "treeview1", data.pTreeView );
    refXml->get_widget_derived( "treeview2", data.pListView );
    refXml->get_widget( "menu1", data.pMenu );
    kit.run( *pWindow );
  }

  return 0;
}

